package test_locally.api.model.event;

import com.google.gson.Gson;
import com.slack.api.model.event.GroupLeftEvent;
import org.junit.Test;
import test_locally.unit.GsonFactory;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.MatcherAssert.assertThat;

public class GroupLeftEventTest {

    @Test
    public void typeName() {
        assertThat(GroupLeftEvent.TYPE_NAME, is("group_left"));
    }

    @Test
    public void deserialize() {
        String json = "{\n" +
                "    \"type\": \"group_left\",\n" +
                "    \"channel\": \"G02ELGNBH\"\n" +
                "}";
        GroupLeftEvent event = GsonFactory.createSnakeCase().fromJson(json, GroupLeftEvent.class);
        assertThat(event.getType(), is("group_left"));
        assertThat(event.getChannel(), is("G02ELGNBH"));
    }

    @Test
    public void serialize() {
        Gson gson = GsonFactory.createSnakeCase();
        GroupLeftEvent event = new GroupLeftEvent();
        String generatedJson = gson.toJson(event);
        String expectedJson = "{\"type\":\"group_left\"}";
        assertThat(generatedJson, is(expectedJson));
    }

}
